%define snapshot 0
%define pre rc

%ifarch %{arm}
%define build_docs 0
%else
%define build_docs 0
%endif

%define qtmajor 5
%define qtminor 15
%define qtsubminor 6

%define rel 1

%define major_private 1
%define qtversion %{qtmajor}.%{qtminor}.%{qtsubminor}

%define libqtsvg %mklibname qt5svg %qtmajor
%define libqtsvg_d %mklibname qt5svg -d

%if %snapshot
%define qttarballdir qtsvg-everywhere-src-%{qtversion}-%pre
%else
%define qttarballdir qtsvg-everywhere-opensource-src-%{qtversion}
%endif

Name: qtsvg5
Version: %{qtversion}
Release: %mkrel %{rel}
Summary: Qt Svg component
Group: Development/Libraries
License: LGPLv2 with exceptions or GPLv3 with exceptions and GFDL
URL:     https://www.qt.io/
Source0: https://download.qt.io/official_releases/qt/%{qtmajor}.%{qtminor}/%{version}/submodules/%{qttarballdir}.tar.xz

# Upstream patches
# https://community.kde.org/Qt5PatchCollection
Patch0001:      0001-Avoid-buffer-overflow-in-isSupportedSvgFeature.patch
Patch0002:      0002-Support-font-size-not-in-pixels.patch
Patch0003:      0003-Fix-text-x-y-when-the-length-is-not-in-pixels.patch
Patch0004:      0004-Improve-parsing-of-r.patch
Patch0005:      0005-Do-stricter-error-checking-when-parsing-path-nodes.patch
Patch0006:      0006-SVG-Image-reading-Reject-oversize-svgs-as-corrupt.patch
Patch0007:      0007-Unconditionally-stop-parsing-after-the-svg-end-tag.patch
Patch0008:      0008-Avoid-undefined-behavior-when-painter-transform-goes.patch
Patch0009:      0009-Fix-assert-with-wrong-number-of-argument-to-animateT.patch

BuildRequires: qtbase5-devel = %version
#Branch Patchs

#Trunk Patchs

#Patch from Mageia

%description
The QtSvg module provides classes for displaying and creating SVG files.

%files
%{_qt5_plugindir}/iconengines/libqsvgicon.so
%{_qt5_plugindir}/imageformats/libqsvg.so

#------------------------------------------------------------------------------

%if %{build_docs}
%package doc
Summary: QtSvg%{qtmajor} APIs and tools docs
Group:   Documentation
BuildArch: noarch
BuildRequires: qttools5
# This one is required to build QCH-format documentation
# for APIs and tools in this package set
BuildRequires: qttools5-assistant

%description doc
Documentation for APIs and tools in QtSvg5 package for use with
Qt Assistant.

%files doc
%{_qt5_docdir}/qtsvg.qch
%{_qt5_docdir}/qtsvg/
%endif

#------------------------------------------------------------------------------

%package -n %{libqtsvg}
Summary: Qt%{qtmajor} Component Library
Group: System/Libraries
Obsoletes: lib64qtsvg5
Provides: lib64qtsvg5 = %version-%{release}
Requires: %name

%description -n %{libqtsvg}
Qt%{qtmajor} Component Library.

The QtSvg module provides classes for displaying and creating SVG files.

%files -n %{libqtsvg}
%{_qt5_libdir}/libQt5Svg.so.%{qtmajor}*

#------------------------------------------------------------------------------

%package -n %{libqtsvg_d}
Summary: Devel files needed to build apps based on QtSvg
Group:    Development/Libraries
Requires: %{libqtsvg} = %version
Provides: libqtsvg5-devel = %version
Provides: libqt5svg-devel = %version
Provides: qtsvg5-devel = %version
Provides: qt5svg-devel = %version

Provides: libqtsvg5-private-devel = %version
Provides: libqt5svg-private-devel = %version
Provides: qtsvg5-private-devel = %version
Provides: qt5svg-private-devel = %version

%description -n %{libqtsvg_d}
Devel files needed to build apps based on QtSvg.

%files -n %{libqtsvg_d}
%{_qt5_libdir}/libQt5Svg.prl
%{_qt5_libdir}/libQt5Svg.so
%{_qt5_libdir}/pkgconfig/Qt5Svg.pc
%{_qt5_libdir}/cmake/Qt5Svg/
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QSvgIconPlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QSvgPlugin.cmake
%{_qt5_archdatadir}/mkspecs/modules/qt_lib_svg.pri
%{_qt5_includedir}/QtSvg/
%{_qt5_archdatadir}/mkspecs/modules/qt_lib_svg_private.pri

#------------------------------------------------------------------------------

%prep
%setup -q -n qtsvg-everywhere-src-%{qtversion}
%apply_patches

rm -frv examples

%build
%qmake_qt5

RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; make -j $RPM_BUILD_NCPUS

%if %{build_docs}
%__make docs
%endif

%install
%make_install INSTALL_ROOT=%{buildroot}

%if %{build_docs}
%make_install install_docs INSTALL_ROOT=%{buildroot}
%endif

# Fix all buildroot paths
find %{buildroot}/%{_qt5_libdir} -type f -name '*prl' -exec perl -pi -e "s, -L%{_builddir}/\S+,,g" {} \;
find %{buildroot}/%{_qt5_libdir} -type f -name '*prl' -exec sed -i -e "/^QMAKE_PRL_BUILD_DIR/d" {} \;
find %{buildroot}/%{_qt5_libdir} -type f -name '*la' -print -exec perl -pi -e "s, -L%{_builddir}/?\S+,,g" {} \;

# Don't reference builddir neither /usr(/X11R6)?/ in .pc files.
perl -pi -e '\
s@-L/usr/X11R6/%{_lib} @@g;\
s@-I/usr/X11R6/include @@g;\
s@-L/%{_builddir}\S+@@g'\
    `find . -name \*.pc`

# .la and .a files, die, die, die.
find %{buildroot} -name '*.la' -delete
find %{buildroot} -name '*.a' -delete



%changelog
* Sun Sep 18 2022 tex - 5.15.6-1pclos2022
- new version
